import { MouseEvent } from 'react';

export function removeFromObjRecursive(name: string, obj: any) {
    return JSON.parse(
        JSON.stringify(obj, function (key, value) {
            if (key !== name) return value;
        })
    );
}

export function replaceEmailsRecursive(name: string, obj: any) {
    return JSON.parse(
        JSON.stringify(obj, function (key, value) {
            if (key === name) return encodeEmail(value);
            return value;
        })
    );
}

export function encodeEmail(str: string) {
    return btoa(str);
}

export function decodeEmail(str: string) {
    return atob(str);
}

export function handleMailtoEvent(e: MouseEvent<HTMLAnchorElement>) {
    const el = e.currentTarget;
    const base = el.dataset.base;
    const mail = decodeEmail(base);
    el.href = 'mailto:' + mail;
    return true;
}

export default {
    removeFromObjRecursive,
    replaceEmailsRecursive,
    encodeEmail,
    decodeEmail,
    handleMailtoEvent,
};
